/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 29-Oct-2004
 *
 */
package uk.ac.ic.doc.kevlar.core.framework;

import uk.ac.ic.doc.kevlar.publicInterfaces.INodeID;

/**
 * @author Daniel Burke
 *
 */
public class SavedPipeTuple {
    
    private long id;
    private PipelineProgram otherProgram;
    private INodeID fromNodeID;
    private INodeID toNodeID;
    private Pipe pipe;

    public SavedPipeTuple(long id, PipelineProgram otherProgram,
            INodeID fromNodeID, INodeID toNodeID, Pipe pipe) {

        this.id = id;
        this.otherProgram = otherProgram;
        this.fromNodeID = fromNodeID;
        this.toNodeID = toNodeID;
        this.pipe = pipe;
    }


    /**
     * @return Returns the fromNodeID.
     */
    INodeID getFromNodeID() {
        return fromNodeID;
    }
    /**
     * @param fromNodeID The fromNodeID to set.
     */
    void setFromNodeID(INodeID fromNodeID) {
        this.fromNodeID = fromNodeID;
    }
    /**
     * @return Returns the id.
     */
    long getId() {
        return id;
    }
    /**
     * @param id The id to set.
     */
    void setId(long id) {
        this.id = id;
    }
    /**
     * @return Returns the otherProgram.
     */
    PipelineProgram getOtherProgram() {
        return otherProgram;
    }
    /**
     * @param otherProgram The otherProgram to set.
     */
    void setOtherProgram(PipelineProgram otherProgram) {
        this.otherProgram = otherProgram;
    }
    /**
     * @return Returns the toNodeID.
     */
    INodeID getToNodeID() {
        return toNodeID;
    }
    /**
     * @param toNodeID The toNodeID to set.
     */
    void setToNodeID(INodeID toNodeID) {
        this.toNodeID = toNodeID;
    }
    /**
     * @return Returns the pipe.
     */
    Pipe getPipe() {
        return pipe;
    }
    /**
     * @param pipe The pipe to set.
     */
    void setPipe(Pipe pipe) {
        this.pipe = pipe;
    }
}
