/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 22-Oct-2004 by toa02
 *
 */
package uk.ac.ic.doc.kevlar.core.framework.internal.loaders;

/**
 * @author toa02
 *  
 */
public interface ILoader {

    public static final String TYPES = "types";

    public static final String PROGRAMS = "programs";

    /**
     * @return The Program Loader which loads programs.
     */
    IProgramLoader getProgramLoader();

    /**
     * @return The Type Loader which loads types.
     */
    ITypeLoader getTypeLoader();

    /**
     * Adds an event observer to listen to events coming from this ILoader.
     * 
     * @param ileo
     *            an ILoadingEventListener that listens to events from this
     *            ILoader
     */
    void addEventObserver(ILoadingEventListener ileo);

    /**
     * @return The custom classloader that can be used to find types and things with.
     */
    public ClassLoader getCustomClassLoader();
    
    /**
     * Causes the current thread to wait until everything is stable.
     *
     */
    void waitTillStable();

}
