/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20-Oct-2004
 *
 */
package uk.ac.ic.doc.kevlar.core.framework.typecheck;

import java.util.HashSet;
import java.util.Set;

/**
 * @author Steve Zymler
 *
 */
public class TypeTreeNode implements ITypeTreeNode
{	
	private Set<ITypeTreeNode> subNodes 
		= new HashSet<ITypeTreeNode>();
	private ITypeTreeNode superNode ;
	private IInterfaceClass typeClass;
	
	// constructor
	public TypeTreeNode( IInterfaceClass typeClass )
	{
		this.typeClass = typeClass ;
		this.superNode = null ;
	}
	
	public TypeTreeNode( IInterfaceClass typeClass, 
	        			 ITypeTreeNode superNode )
	{
		this.typeClass = typeClass ;
		this.superNode = superNode ;
	}
	
	// Interface implementation methods.
	public ITypeTreeNode getSuperNode() 
	{				
		return superNode;
	}

	public void setSuperNode(ITypeTreeNode superNode) 
	{
		this.superNode = superNode;
	}

	public Set<ITypeTreeNode> getSubNodes() 
	{
		return subNodes;
	}

	public void addSubNode(ITypeTreeNode subNode) 
	{
		subNode.setSuperNode( this );
		subNodes.add( subNode );			
	}

	public IInterfaceClass getInterfaceClass() 
	{
		return typeClass;
	}

	public void setInterfaceClass(IInterfaceClass typeClass) 
	{
		this.typeClass = typeClass ;			
	}	
}	