/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 21-Oct-2004
 */
package uk.ac.ic.doc.kevlar.gui.internal.caches;

import java.util.HashMap;
import java.util.Iterator;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;

/**
 * @author Marc
 **/
public class ColorCache {

	private static HashMap<String, Color> colors;
	
	public static Color get(int red, int green, int blue) {
		
		if (colors == null) {
			
			colors = new HashMap<String, Color>();
			
		}
		
		String colorKey = Integer.toString(red)+":"+Integer.toString(green)+":"+Integer.toString(blue);
		
		if (colors.containsKey(colorKey)) {
			
			return colors.get(colorKey);
			
		} else {
			
//			System.out.println("Color allocated: "+colorKey);
			
			Color newColor = new Color(Display.getCurrent(), red, green, blue);
			colors.put(colorKey, newColor);
			return newColor;
			
		}
		
	}
	
	public static void dispose() {
		
		Iterator i = colors.values().iterator();
		
		while (i.hasNext()) {
			
			Color color = (Color)i.next();
			color.dispose();
			
		}
		
	}
    
}
