/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 23.10.2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.dragdrop;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.AMouseListenerObject;
import uk.ac.ic.doc.kevlar.gui.internal.CanvasManager;
import uk.ac.ic.doc.kevlar.gui.internal.help.HelpManager;


/**
 * @author ei02
 *
 */
public abstract class ADraggableObject extends AMouseListenerObject{
	
	protected Point mouseDownPoint;
	
	public ADraggableObject() {
	    
	    super();
	    
	}
	
	public void mousePress(Point position, int button) {
	    
	    super.mousePress(position, button);
	    mouseDownPoint = position;
	    getMouseFocus();
	    
	}

	public void mouseRelease(Point position, int button) {
	    
	    super.mouseRelease(position, button);
	    mouseDownPoint = null;
	    releaseMouseFocus();
	    
	}
	
	public void mouseMoving(Point position) {
	    
//		if ((mouseDownPoint != null) && (!CanvasManager.getSingleton().hasDragObject()) && (Utils.distance(position, mouseDownPoint) > 5)) {
		if ((mouseDownPoint != null) && (!CanvasManager.getSingleton().hasDragObject())) {
		    
		    Point dragOffset = mouseDownPoint;
			mouseDownPoint = null;
			HelpManager.getSingleton().hideHelp();
			onDrag(dragOffset);
			
		}
		
	}
		
	public boolean capturesMouse() {
	    
	    return true;
	    
	}
	
	public void onDrag(Point offset) {
	    
	    /* Default implementation for onDrag */
	    
	}
	
	public void dropped(IDropTarget target) {
	    
	    /* Default implementation for dropped */
	    
	}
	
}
