/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 02.11.2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.pipeline;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.api.programs.arguments.IArgumentHelp;
import uk.ac.ic.doc.kevlar.api.programs.arguments.IBasicArgumentInfo;
import uk.ac.ic.doc.kevlar.gui.GUIManager;
import uk.ac.ic.doc.kevlar.gui.internal.caches.ColorCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.FontCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.Utils;
import uk.ac.ic.doc.kevlar.gui.internal.help.HelpManager;
import uk.ac.ic.doc.kevlar.gui.internal.widgets.RollOverButton;
import uk.ac.ic.doc.kevlar.hial.IHialProgram;
import uk.ac.ic.doc.kevlar.hial.IRefObject;
import uk.ac.ic.doc.kevlar.publicInterfaces.INode;

/**
 * @author ei02
 *
 */
public class InputNodeEntry extends AIONodeEntry {

    private static final String INPUT_SKIN_NAME = "inputheading";
    
	InputNodeEntry(INode node, int positionIndex, Program program) {
	    
	    super(node, positionIndex, program);
		nodeWidget = new InputNode(this);
	    nodeWidget.setPosition(new Point(3, 3));
		addChild(nodeWidget);
	    
	}
	
	public void drawBefore(GC gc, Rectangle redrawArea) {

	    Utils.drawHorizontalBar(gc, INPUT_SKIN_NAME, new Rectangle(-redrawArea.x, -redrawArea.y, area.width, area.height));
	    
		gc.setForeground(ColorCache.get(0, 0, 0));
	    gc.setFont(FontCache.get("Arial", 7, SWT.NORMAL));
	    
        Utils.drawText(gc, prefix+node.getName(), new Rectangle(27-redrawArea.x, -redrawArea.y, area.width-30, area.height), Utils.ALIGN_LEFT);
	    
	}

}
