/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 18-Nov-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.popup;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import uk.ac.ic.doc.kevlar.gui.internal.ADrawableObject;
import uk.ac.ic.doc.kevlar.gui.internal.AMouseListenerObject;
import uk.ac.ic.doc.kevlar.gui.internal.caches.ColorCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.FontCache;
import uk.ac.ic.doc.kevlar.gui.internal.caches.Utils;

/**
 * @author Marc
 **/
public class PopUpBox extends AMouseListenerObject {

    protected static final Point POP_UP_LIST_BOX_SIZE = new Point(150, 100);
    protected static final String POP_UP_LIST_BOX_SKIN_NAME = "blackbox";
    
    protected ADrawableObject contents;
    protected String name;
    
	public PopUpBox() {
		
		super();
		setSize(POP_UP_LIST_BOX_SIZE);
		name = "";
		
	}
	
	public void setContents(ADrawableObject contents) {
	    
	    contents.setPosition(new Point(2, 20));
	    contents.setSizeFillBoth(new Point(5, 2));
	    addChild(contents);
	    this.contents = contents;
	    
	}
	
	public void setName(String name) {
	    
	    this.name = name;
	    
	}
	
	public void drawBefore(GC gc, Rectangle redrawArea) {
	    
	    Utils.drawBox(gc, new Rectangle(-redrawArea.x, -redrawArea.y, area.width, area.height), POP_UP_LIST_BOX_SKIN_NAME);
	    
		gc.setForeground(ColorCache.get(255, 255, 255));
	    gc.setFont(FontCache.get("Arial", 8, SWT.BOLD));
	    gc.drawText(name, 5-redrawArea.x, 5-redrawArea.y, true);        	    
	    
	}
	
	public void popUpAt(Point position) {
	    
	    setPosition(position);
	    PopUpManager.getSingleton().showPopUp(this);
	    
	}
	
	public boolean capturesMouse() {
	    
	    return true;
	    
	}
	
}
