/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20.10.2004
 *
 */

package uk.ac.ic.doc.kevlar.gui.internal.taskpane.directorypane;

import java.util.ArrayList;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.keyboard.KeyboardManager;
import uk.ac.ic.doc.kevlar.gui.internal.keyboard.states.DirectoryPaneState;

/**
 * @author ei02
 *
 */
public class DirectoryPane extends ADirectoryBrowsePane {

    public DirectoryPane(Point position){
        
        super(position, 0);
        
    }
    
    public String getName() {
        
        return "Directory";
        
    }
        
    public void populateWithFiles(int positionIndex, ArrayList childNodes, int animationMode) {
        
        for (int i = 0; i<childNodes.size(); i++) {
            
            IDirectoryTreeNode child = (IDirectoryTreeNode) childNodes.get(i);
            
            if (child instanceof IFileNode) {
                
                ADirectoryTreeNodeEntry entry = getEntry(child);
                
                if (entry != null) {
                    
                    entry.setIndex(positionIndex);
                    
                } else {
                    
                    entry = new FileEntry((IFileNode)child, positionIndex, this, animationMode);
                    super.entries.add(entry);
                    addChild(entry);
                    
                }
                
                positionIndex++;
                
            } 
            
        }	
        
    }
    
    public void activate() {
        
        if (!(KeyboardManager.getSingleton().getState() instanceof DirectoryPaneState)) {
        
            KeyboardManager.getSingleton().setState(new DirectoryPaneState());
            
        }
        
    }
    
}
