/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 29-Dec-2004
 *
 */
package uk.ac.ic.doc.kevlar.gui.internal.taskpane.loadpane;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.graphics.Point;

import uk.ac.ic.doc.kevlar.gui.internal.pipeline.Program;

/**
 * @author Kate
 *
 */
public class MacroLoadStructure {
	
	int macroID;
	List<Program> macroPrograms;
	List references;
	List innerMacroIds;
	//ILayoutData layout;
	Point position;
	
	public MacroLoadStructure(int macroID)
	{
		this.macroID = macroID;
		macroPrograms = new ArrayList<Program>();
		references = new ArrayList();
		innerMacroIds = new ArrayList();	
	}
	
	public void addPrograms(Program program)
	{
		macroPrograms.add(program);
	}
	
	public void addReference(String ref)
	{
		references.add(ref);
	}
	
	public void addInnerIds(int id)
	{
		innerMacroIds.add(new Integer(id));
	}
	
	public List getReference()
	{
		return references;
	}
	
	public List<Program> getPrograms()
	{
		return macroPrograms;
	}
	
	public void setPosition(Point position)
	{
		this.position = position;
	}
	
	public Point getPosition()
	{
		return position;
	}
	
	public List getInnerMacroIds()
	{
		return innerMacroIds;
	}
}
