/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 20-Oct-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package uk.ac.ic.doc.kevlar.hial.internal.programTree;

import java.util.List;
import java.util.TreeSet;

import uk.ac.ic.doc.kevlar.hial.IProgramCategoryNode;
import uk.ac.ic.doc.kevlar.hial.IProgramTreeNode;
import uk.ac.ic.doc.kevlar.hial.IProgramTreeVisitor;
import uk.ac.ic.doc.kevlar.publicUtil.collections.IImmutableList;
import uk.ac.ic.doc.kevlar.publicUtil.collections.ImmutableArrayList;

/**
 * @author Daniel Burke
 */
public class ProgramCategoryNode extends ProgramTreeNode implements IProgramCategoryNode {

	private IImmutableList<IProgramTreeNode> children;
	private String name;
	boolean root = false;
	
	public ProgramCategoryNode(List<IProgramTreeNode> children)
	{
		this(children, "root");
		root = true;
	}
	
	public ProgramCategoryNode(List<IProgramTreeNode> children, String name)
	{
		setChildren(children);
		this.name = name;
	}
	
	public void acceptVisitor(IProgramTreeVisitor visitor) {
		visitor.categoryNode(this);
	}

	public IImmutableList<IProgramTreeNode> getChildren() {
		return children;
	}

	public void setChildren(List<IProgramTreeNode> children) {
		
	    
	    TreeSet<IProgramTreeNode> sortedChildren = new TreeSet<IProgramTreeNode>(children);
		this.children = new ImmutableArrayList<IProgramTreeNode>( sortedChildren );
		
		for(IProgramTreeNode child : this.children)
		{
			if(child instanceof ProgramTreeNode)
			{
				((ProgramTreeNode)child).setParent(this);
			}
			else
			{
				throw new IllegalArgumentException("Only a subclass of " +
						"ProgramTreeNode is allowed as children");
			}
		}
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public boolean isRoot()
	{
		return root;
	}
}
