/*******************************************************************************
* Copyright (c)                                                                *
*           2005   Tristan Allwood,                                            *
*           2005   Daniel Burke,                                               *
*           2005   Marc Hull,                                                  *
*           2005   Ekaterina Itskova,                                          *
*           2005   Steve Zymler                                                *
*                                                                              *
* Permission is hereby granted, free of charge, to any person obtaining a      *
* copy of this software and associated documentation files (the                *
* "Software"), to deal in the Software without restriction, including          *
* without limitation the rights to use, copy, modify, merge, publish,          *
* distribute, sublicense, and/or sell copies of the Software, and to           *
* permit persons to whom the Software is furnished to do so, subject to        *
* the following conditions:                                                    *
*                                                                              *
* The above copyright notice and this permission notice shall be included      *
* in all copies or substantial portions of the Software.                       *
*                                                                              *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                   *
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.       *
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY         *
* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,         *
* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE            *
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                       *
*******************************************************************************/
/*
 * Created on 29-Oct-2004
 *
 */
package uk.ac.ic.doc.kevlar.publicUtil.collections;

/**
 * @author Daniel Burke
 *
 */
public final class Tuple3<T, Q, S> {
	T first;
	Q second;
	S third;
	
	public Tuple3(T first, Q second, S third)
	{
		this.first = first;
		this.second = second;
		this.third = third;
	}

	/**
	 * @return Returns the first.
	 */
	public T getFirst() {
		return first;
	}
	/**
	 * @param first The first to set.
	 */
	public void setFirst(T first) {
		this.first = first;
	}
	/**
	 * @return Returns the second.
	 */
	public Q getSecond() {
		return second;
	}
	/**
	 * @param second The second to set.
	 */
	public void setSecond(Q second) {
		this.second = second;
	}
    /**
     * @return Returns the third.
     */
    public S getThird() {
        return third;
    }
    /**
     * @param third The third to set.
     */
    void setThird(S third) {
        this.third = third;
    }
    
    public static <T, Q, S>  Tuple3<T, Q, S> make(T first, Q second, S third)
    {
        return new Tuple3<T, Q, S>(first, second, third);
    }
}